const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ClientsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const clients = await db.clients.create(
      {
        id: data.id || undefined,

        first_name: data.first_name || null,
        last_name: data.last_name || null,
        birth_date: data.birth_date || null,
        phone: data.phone || null,
        address: data.address || null,
        id_type: data.id_type || null,
        id_number: data.id_number || null,
        id_issue_date: data.id_issue_date || null,
        license_number: data.license_number || null,
        license_issue_date: data.license_issue_date || null,
        id_copy_url: data.id_copy_url || null,
        license_copy_url: data.license_copy_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await clients.setTenant(data.tenant || null, {
      transaction,
    });

    await clients.setAgences(data.agences || null, {
      transaction,
    });

    return clients;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const clientsData = data.map((item, index) => ({
      id: item.id || undefined,

      first_name: item.first_name || null,
      last_name: item.last_name || null,
      birth_date: item.birth_date || null,
      phone: item.phone || null,
      address: item.address || null,
      id_type: item.id_type || null,
      id_number: item.id_number || null,
      id_issue_date: item.id_issue_date || null,
      license_number: item.license_number || null,
      license_issue_date: item.license_issue_date || null,
      id_copy_url: item.id_copy_url || null,
      license_copy_url: item.license_copy_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const clients = await db.clients.bulkCreate(clientsData, { transaction });

    // For each item created, replace relation files

    return clients;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const clients = await db.clients.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.first_name !== undefined)
      updatePayload.first_name = data.first_name;

    if (data.last_name !== undefined) updatePayload.last_name = data.last_name;

    if (data.birth_date !== undefined)
      updatePayload.birth_date = data.birth_date;

    if (data.phone !== undefined) updatePayload.phone = data.phone;

    if (data.address !== undefined) updatePayload.address = data.address;

    if (data.id_type !== undefined) updatePayload.id_type = data.id_type;

    if (data.id_number !== undefined) updatePayload.id_number = data.id_number;

    if (data.id_issue_date !== undefined)
      updatePayload.id_issue_date = data.id_issue_date;

    if (data.license_number !== undefined)
      updatePayload.license_number = data.license_number;

    if (data.license_issue_date !== undefined)
      updatePayload.license_issue_date = data.license_issue_date;

    if (data.id_copy_url !== undefined)
      updatePayload.id_copy_url = data.id_copy_url;

    if (data.license_copy_url !== undefined)
      updatePayload.license_copy_url = data.license_copy_url;

    updatePayload.updatedById = currentUser.id;

    await clients.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await clients.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await clients.setAgences(
        data.agences,

        { transaction },
      );
    }

    return clients;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const clients = await db.clients.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of clients) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of clients) {
        await record.destroy({ transaction });
      }
    });

    return clients;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const clients = await db.clients.findByPk(id, options);

    await clients.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await clients.destroy({
      transaction,
    });

    return clients;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const clients = await db.clients.findOne({ where }, { transaction });

    if (!clients) {
      return clients;
    }

    const output = clients.get({ plain: true });

    output.claims_client = await clients.getClaims_client({
      transaction,
    });

    output.reservations_client = await clients.getReservations_client({
      transaction,
    });

    output.tenant = await clients.getTenant({
      transaction,
    });

    output.agences = await clients.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.first_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('clients', 'first_name', filter.first_name),
        };
      }

      if (filter.last_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('clients', 'last_name', filter.last_name),
        };
      }

      if (filter.phone) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('clients', 'phone', filter.phone),
        };
      }

      if (filter.address) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('clients', 'address', filter.address),
        };
      }

      if (filter.id_number) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('clients', 'id_number', filter.id_number),
        };
      }

      if (filter.license_number) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'clients',
            'license_number',
            filter.license_number,
          ),
        };
      }

      if (filter.id_copy_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('clients', 'id_copy_url', filter.id_copy_url),
        };
      }

      if (filter.license_copy_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'clients',
            'license_copy_url',
            filter.license_copy_url,
          ),
        };
      }

      if (filter.birth_dateRange) {
        const [start, end] = filter.birth_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            birth_date: {
              ...where.birth_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            birth_date: {
              ...where.birth_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.id_issue_dateRange) {
        const [start, end] = filter.id_issue_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            id_issue_date: {
              ...where.id_issue_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            id_issue_date: {
              ...where.id_issue_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.license_issue_dateRange) {
        const [start, end] = filter.license_issue_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            license_issue_date: {
              ...where.license_issue_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            license_issue_date: {
              ...where.license_issue_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.id_type) {
        where = {
          ...where,
          id_type: filter.id_type,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.clients.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('clients', 'first_name', query),
        ],
      };
    }

    const records = await db.clients.findAll({
      attributes: ['id', 'first_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['first_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.first_name,
    }));
  }
};
